;Ŀ
; PFH.ASM                                      
; Copyright (C)1994,1996 Ivan Ristic           
;

        .386

_DATA   SEGMENT BYTE PUBLIC USE32 'DATA'

_act_page:      dd      0    ; active page
_pagedir:       dd      0    ; address of secund. table
_vbase:         dd      0    ; address of video memory

_DATA   ENDS


_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
        ASSUME cs:_TEXT

PUBLIC  getcr3_, getcr0_, new14_, _pagedir, _vbase


new14_:
        push    eax
        push    ebx

        call    get_new_            ;
        cmp     eax,_act_page       ; if (_act_page==new_page)
        jz      @nmine              ;    it's not our PF

        push    eax
        mov     eax,_act_page       ; reset old page
        call    reset_
        pop     eax

        mov     _act_page,eax       ; set new one
        call    set_

        push    edx                 ; VESA call to change
        shl     eax,0               ; the active page of video card
        mov     edx,eax             ;
        xor     ebx,ebx             ; we need the shifting to fix
        mov     eax,0x4f05          ; VESA granularity. The shift
        int     0x10                ; amount differs.
        pop     edx                 ; For Trio64V+ we do not need it.

@nmine:
        pop     ebx
        pop     eax
        retf

get_new_:

        mov     eax,cr2             ; is this a call to us?
        and     eax,0FFC00000h
        cmp     eax,_vbase
        jnz     @@out

        mov     eax,cr2             ; yeah, it is
        shr     eax,12              ; which one is new page?
        and     eax,03ffh
        shr     eax,4
        ret

@@out:  mov     eax,_act_page
        ret

set_:                               ; set presence bits
        push    eax
        push    ebx
        push    ecx

        imul    eax,64
        add     eax,_pagedir
        mov     ebx,eax
        mov     ecx,16
@@s1:   mov     eax,[ebx]
        or      eax,1
        mov     [ebx],eax
        add     ebx,4
        loop    @@s1

        mov     eax,cr3
        mov     cr3,eax

        pop     ecx
        pop     ebx
        pop     eax
        ret

reset_:                             ; reset presence bits
        push    eax
        push    ebx
        push    ecx

        imul    eax,64
        add     eax,_pagedir
        mov     ebx,eax
        mov     ecx,16
@@r1:   mov     eax,[ebx]
        and     eax,0FFFFFFFEh
        mov     [ebx],eax
        add     ebx,4
        loop    @@r1

        mov     eax,cr3
        mov     cr3,eax

        pop     ecx
        pop     ebx
        pop     eax
        ret

getcr3_:
        mov     eax,cr3
        mov     cr3,eax             ; this line resets the internal cache
        ret

getcr0_:
        mov     eax,cr0
        mov     cr0,eax
        ret

_TEXT   ENDS
        END
